Description

As a user, | can sync RPM/SRPM/Erratum from a remote Yum/DNF repository.
Other unknown types of a content should be ignored during sync.
This story is complete when:

® | can initiate a sync from remote Yum/DNF repo

* The sync completes without error
* | can see that the expected content was added to the repo

Pseudo Code First Stage Example

The sync will create a Stages API first stage and then pass all of them to DeclarativeVersion. Here is some pseudocode that can run
inside of the __call__() of the first stage.

with ProgressBar (message='Downloading Metadata') as pb:

repomd_url = url = self.remote.url + '/repodata/repomd.xml'

downloader = self.remote.get_downloader (repomd_url) # get the downloader

result = await downloader.run() # downloading happens here

pb.increment () # tell the user we downloading something

other_metadata_files = get_other_metadata_files_as_list (result) # gives urls of comps

, updateinfo, etc.

downloaders = []

for url in other_metadata_files:
downloader = self.remote.get_downloader (repomd_url) # get the downloader
downloaders.append (downloader.run()) # This only creates the coroutine, it

doesn't run it

while downloaders:

done, downloaders = await asyncio.wait (pending, return_when=asyncio.FIRST_C
OMPLETED)
for finished_downloader in done:
pb.increment () # tell the user we downloading something
in_memory_parsed_metadata = createrepo_c.load_xml (finished_do

wnloader.path)
for package in in_memory_parsed_metadata:
if is_updaterecord(package) :
content = UpdateRecord(content_data_
from_package)
artifact = Artifact (digest_data_from
_package)

da DeclarativeArtifact (artifact, u

rl, entry.relative_path, self.remote)

dc = DeclarativeContent (content=file
, d_artifacts=[dal)

await out_g.put (dc)
if is_packagerecord (package) :
# Similar to what we did only usin
g RpmContent / SrpmContent

The call function will become long, so consider breaking it up into additional coroutine methods on the object. For example if we
made a build_da_dc_and_emit() coroutine it would be defined like:

async def build_da_dc_and_emit (self, content, artifact):
da = DeclarativeArtifact (artifact, url, entry.relative_path, self.remote)
dc = DeclarativeContent (content=file, d_artifacts=[dal)
await out_g.put (dc)

# Then in your code call it with:
await self.build_da_dc_and_emit (content, artifact)

Subtasks:

Task # 3933: Save UpdateCollection and UpdateCollectionPackage in bulk CLOSED - CURRENTHF
Story # 3934: As a plugin writer, | can have a stage that removes duplicates CLOSED - CURRENTH
Task # 3942: Store a digest of the fields for an UpdateRecord NEW

Related issues:

Related to RPM Support - Test #4108: Test syncing RPM/DRPM/SRPM/Erratum ASSIGNED

Blocked by RPM Support - Task #3199: Create model(s) for a Package content type CLOSED - CURRENTRELEASE

Associated revisions

Revision d9f95bd8 - 08/23/2018 10:49 PM - daviddavis

Initial pass at syncing rpm and erratum content
This handles creating packages and update records from an RPM remote. UpdateCollections and their packages are not included.

ref #3202 https://pulp.plan.io/issues/3202

Revision fcd156b3 - 08/24/2018 07:11 PM - daviddavis

Parsing erratum relationships and storing them on the model

ref #3202 https://pulp.plan.io/issues/3202

History

#1 - 12/14/2017 08:17 PM - ttereshc
- Sprint/Milestone set to Pulp 3 RPM MVP

#2 - 12/14/2017 08:19 PM - ttereshc
- Blocked by Task #3199: Create model(s) for a Package content type added

#4 - 02/20/2018 07:18 PM - ttereshc

- Subject changed from As a user, | can sync RPM/SRPM from a remote Yum/DNF repository to As a user, | can sync RPM/SRPM/Erratum from a
remote Yum/DNF repository

#5 - 02/20/2018 07:19 PM - ttereshc

- Description updated
#6 - 05/25/2018 02:00 PM - ttereshc
- Sprint set to Sprint 37

#7 - 06/01/2018 11:11 PM - rchan
- Sprint changed from Sprint 37 to Sprint 38

#8 - 06/26/2018 03:16 PM - rchan
- Sprint changed from Sprint 38 to Sprint 39

#9 - 07/16/2018 01:07 AM - dkliban@redhat.com
- Sprint deleted (Sprint 39)

#10 - 08/09/2018 03:16 PM - ttereshc
- Sprint set to Sprint 41

#11 - 08/09/2018 04:48 PM - bmbouter

- Description updated

Posting some sync pseudocode

#12 - 08/09/2018 05:15 PM - bmbouter

- Description updated

Adding an example about breaking the code up into smaller coroutines.

#13 - 08/10/2018 10:40 AM - milan
- Status changed from NEW to ASSIGNED

- Assignee set to milan

#14 - 08/13/2018 10:17 AM - milan
- Status changed from ASSIGNED to NEW

- Assignee deleted (milan)

#15 - 08/13/2018 06:03 PM - ttereshc
- Status changed from NEW to ASSIGNED

- Assignee set to ttereshc

#16 - 08/19/2018 06:20 PM - ttereshc
WIP PR https://github.com/pulp/pulp_rpm/pull/1160

#17 - 08/27/2018 03:03 PM - rchan
- Sprint changed from Sprint 41 to Sprint 42

#18 - 09/13/2018 03:35 PM - daviddavis
- Status changed from ASSIGNED to MODIFIED

#19 -10/31/2018 02:17 PM - kersom

- Related to Test #4108: Test syncing RPM/DRPM/SRPM/Erratum added
#20 - 04/26/2019 10:37 PM - bmbouter
- Tags deleted (Pulp 3)

#21 - 12/13/2019 08:54 AM - ttereshc
- Status changed from MODIFIED to CLOSED - CURRENTRELEASE
